TheSwamp

Code Red => AutoLISP (Vanilla / Visual) => Topic started by: reltro on May 31, 2014, 05:45:16 AM

Title: Radial Menu
Post by: reltro on May 31, 2014, 05:45:16 AM
Hey People...

I first posted the Radial-Menu in this Thread: http://www.theswamp.org/index.php?topic=12813.msg521952#msg521952

Since then I improved the functionality to add following stuff:

* last command will be stored in the function itself
   - can be called
      - by pressing ENTER or SPACE
      - LEFT-Click in the Center or the free Space below

* different shortcuts for "right-action" and "left-action"
* as ShortCuts strings can be used
   - first the UpperCase Chars are searched
         (wcmatch "shortcut" (strcase "*typed*"))
   - then the whole sting is searched
         (eq (strcase "shortcut") (strcase "typed"))
   
   Note:
      To find a proper shortcut, the entries are searched counterclockwise.
      If there is a SubMenu then this one will be searched right after the parentMenu.

* If there is a SubMenu and no proper command for the current action (Ex. RIGHTCLICK) the SubMenu will be display at it own.
* To open a SubMenu at his own, u can also press TAB while pointing the ParentMenu-Entry
* To switch back to the last shown ParentMenu point at the center or the free Space below and Press TAB or RIGHTCLICK.

--------------------------------------------------------

At the moment there are 2 Versions:
   - RadialMenu-allVectors.lsp
         - the displayed Menu is made from vectors and drawn with grvecs
         
   - RadialMenu-titleMtext.lsp
         - the displayed Menu is made from vectors and drawn with grvecs
         - the title (name of the current pointed Menu-Entry) is drawn using MText
            NOTE: if the View is rotated with 3D-Orbit the Mtext isn't shown in the right direction
            

            
To modify the Menu at ur own look at the 2 examples and the Tree-Map in the attachment.

To draw symbols at ur own:
   * draw a line graphic near the origin of the WCS.
   * the origin (0 0 0) will be the Center of the symbol/graphic shown in the Menu.
   * the maximal Extension of the graphic should be near 1
   * to add colors use the object color (GC 62)
   * then run CreateSymbol.lsp and select the lines
   * copy the result and add it to ur menu
   
Usage: (prepared)
   - load RadialMenu-***.lsp
   - load ModifyDraw.lsp
   - type: Interface
   - hit ENTER


EDIT
LAST VERSION:
http://www.theswamp.org/index.php?topic=47177.msg522549#msg522549

reltro
Title: Re: Radial Menu
Post by: WILL HATCH on June 01, 2014, 01:33:29 AM
This is awesome, I like the direction you've taken with this.  The only thing I would like to see is the ability to put into a 'continuous' mode where the menu automagically opens up after the command saving an additional right click.

I'm waiting for my pair of Myo armbands to come in, thinking they could save a huge amount of time in the drafting department with some toying, and this kind of idea is a great start.

Thanks for sharing
Title: Re: Radial Menu
Post by: ROBBO on June 02, 2014, 01:19:44 PM
reltro,

A snappy and well thought out routine. May add this to a right click menu.
It would be even better as WILL HATCH suggested:
...I would like to see is the ability to put into a 'continuous' mode...
Also for people like me who redefine commands  - is to add a period to the commands to allow original command to be called. Example: _.LINE instead of _LINE. Nevertheless thank you for sharing.

Kindest regards,  Robbo
Title: Re: Radial Menu
Post by: reltro on June 03, 2014, 02:14:03 PM
Hey people...

I cleaned up the mess a lil bit, and rewrote most of the routine to add other functionallity...

I skipped the version with the MText, I don't like it... it only makes problems....

added:

- Menu is now scaleable with the +/- keys
     * the last setting will be saved in the function
     * shift++ and shift+- will recreate the initial scale

- Markers if a button has a LEFT-click-action or/and RIGHT-click-action [EDIT]
     * can be toggled OFF by pressing Shift+#

- The whole menu (the drawn vectors) is precalulated

- The whole Menu  can be written to a File wih contains all needed

- by pressing # it toggles between graphics and text

- pointing on a button and pressing ? gives some tips for it
     *changed the Input a lil bit to add a 'Description-Tag

- pointed button is highlighted


improved

- ShortCuts:
    *  If a button is pointed and a Shortcut is given, the menu will be searched only in this "Category" with all SubMenus
    *  If no button is pointed it searches like as in the previous version



******************
As there are a lot of downloads, but no comments, I will post a prepared Menu, but not the function wich one creates it...
Anybody is welcome to make some suggestions, and ask for the Create-function

reltro
Title: Re: Radial Menu
Post by: reltro on June 03, 2014, 02:24:12 PM
This is awesome, I like the direction you've taken with this.  The only thing I would like to see is the ability to put into a 'continuous' mode where the menu automagically opens up after the command saving an additional right click.

I'm waiting for my pair of Myo armbands to come in, thinking they could save a huge amount of time in the drafting department with some toying, and this kind of idea is a great start.

Thanks for sharing

Hey WILL HATCH,
thanks for the feedback

Would also like the 'continuous' way, but it isn't that easy... the action is evaluated at the very end outside of the menu-routine (to avoid namespace-collisions).
The only way to chatch the end of a an action, I think, would be a reactor (Ex. commandended); I don't like them ;)

But u can try it ;)

.........
Myo armbands :  :-o this is so nice! ;) please give some feedback if they arrive!


reltro,

A snappy and well thought out routine. May add this to a right click menu.
It would be even better as WILL HATCH suggested:

...I would like to see is the ability to put into a 'continuous' mode...
Also for people like me who redefine commands  - is to add a period to the commands to allow original command to be called. Example: _.LINE instead of _LINE. Nevertheless thank you for sharing.

Kindest regards,  Robbo


Hey robbo
thanks for the feedback

I don't know how to add a function to a right-click-menu (not via lisp), so give me a hint ;)

The DOTS... u are right, I modified them in the last post


reltro
Title: Re: Radial Menu
Post by: WILL HATCH on June 03, 2014, 02:28:50 PM
- Markers if a button has a LEFT-click-action or/and LEFT-click-action
     * can be toggled OFF by pressing Shift+#
Not sure what you mean here
Title: Re: Radial Menu
Post by: reltro on June 03, 2014, 02:53:16 PM
There is a small red line if the button have a left-click-action, and a green one if there is one for right click...

Ex:
- draw has no action, no line
- move has right and left
  Left: (command "_.line")
  Right: (command "_.line" "_prevoius")

With shift+# the can be hidden/shown

[EDIT: oh I don't not reconized the mistake in the previous post... thanks and corrected]

Reltro
Title: Re: Radial Menu
Post by: ROBBO on June 04, 2014, 02:36:41 AM
reltro,

Great improvements. The only thing I could not get to work is the toggle (Shift+#) for the markers.

One thing I think that could improve this, is to perhaps have a Help button, perhaps near the centre of the graphic (similar to your ? function) to explain how to operate the tool as described in your updated post.

Keep up the good work. Kind regards, Robbo.

BTW - I load this lisp in on start-up and created a shortcut key Shift+Z to call the tool.
 
Title: Re: Radial Menu
Post by: reltro on June 04, 2014, 09:58:52 AM
reltro,

Great improvements. The only thing I could not get to work is the toggle (Shift+#) for the markers.

One thing I think that could improve this, is to perhaps have a Help button, perhaps near the centre of the graphic (similar to your ? function) to explain how to operate the tool as described in your updated post.

Keep up the good work. Kind regards, Robbo.

BTW - I load this lisp in on start-up and created a shortcut key Shift+Z to call the tool.

Hm, the shift+# key has on my keyboard here, the code returned from (grread) is (2 39)... and (chr 39) is "'" (the quote-symbol)...
I think its because I have a german keyboard... I will build in some option to modify the keys, so everyone can adjust them at his own... idea?

I already began to implement such a option-command to modify the displayed colors...

------
The thing with the help on the center is a good idea... The center has allready a help(?)-action... it displays the header with contact and all the stuff, so it wouldn't be hard to add some other things...
At the moment I use the (alert ...) function to display it, but it would be nice to build a simple dcl, but I don't know a lot of dcl... maybe you/someone can help?

reltro
Title: Re: Radial Menu
Post by: ROBBO on June 04, 2014, 10:16:21 AM
reltro,

I  know very little about dcl too!. Have used the alert command frequently though.

I have also used the browser command to open up a help file - for example:
^C^C_BROWSER "C:/folder/in/file/search/path/MY_help.mht"

Can even be a pdf.

Cheers, Robbo.
Title: Re: Radial Menu
Post by: Bhull1985 on June 04, 2014, 11:20:15 AM
DCL is simple as pie.
Here's an example to show exactly how easy it is.
Code: [Select]
img : image_button
{
height = 5.5;
width = 18.00;
fixed_width = true;
fixed_height = true;
alignment = centered;
color = -2;
}
txt : text {fixed_width = true; alignment = centered; }
col : column {fixed_width = true; width = 28; }

  //---------------------------------------------------------------------------------------------------------


  controlvalves : dialog {
   label = "EPCO Control Valves"; spacer;
: row
{
   : col
   {
: img { key = "Slide1"; } : txt { label = "Hand Op. Butterfly Control Valve"; } spacer_1;
: img { key = "Slide2"; } : txt { label = "Hand Op. 3-Way Control Valve"; } spacer_1;
: img { key = "Slide3"; } : txt { label = "Diaph. Act. w Ind. Valve Action"; } spacer_1;
: img { key = "Slide4"; } : txt { label = "Butterfly CV (Shut-Down Valve)"; } spacer_1;
: img { key = "Slide5"; } : txt { label = "Globe Control Valve"; } spacer_1;
: img { key = "Slide6"; } : txt { label = "Ball Type Control Valve"; }
   }
   : col
   {
: img { key = "Slide7"; } : txt { label = "Control Valve w Hand Actuator"; } spacer_1;
: img { key = "Slide8"; } : txt { label = "Angle Control Valve"; } spacer_1;
: img { key = "Slide9"; } : txt { label = "Pilot Valve w Manual Reset"; } spacer_1;
: img { key = "Slide10"; } : txt { label = "Backpressure Reg.- Int. Sensing"; } spacer_1;   
: img { key = "Slide11"; } : txt { label = "Backpressure Reg.- Ext. Sensing"; } spacer_1;
: img { key = "Slide12"; } : txt { label = "Pres. Red. Reg.- Int. Sensing"; }
   }
}
spacer; cancel_button;     
}///manualvalves
obviously this DCL is meant to display image slides but it shows how simple it is to modify ,
you'd simply set your controls for what you are going to be using at the top of the routine,
and then "call" them throughout your dcl, using the
: col/ : row
commands in order to organize them where you'd like them to appear.
There are more commands and controls that could be defined, such as text PARAGRAPHS, which would allow for multiline text formatting a bit better than the text controls shown in this example.
Wish I could do it for you, don't have the time quite yet!
Title: Re: Radial Menu
Post by: reltro on June 04, 2014, 05:50:18 PM
Hey People...

There is a new Version of RadialMenu... :)

Version 2.1a

- Added a Keyword-Menu to modify look and behaviour, wich can be opened by pressing ? in the center or the free space below.
      * there the option-keyword ? gives a feedback and redirect u to this URL

- Added a Snappy-Mode so the Menu follows the cursor

- Added a option to show the whole Menu at the same time

- Added the possiblity to switch between "singleChar"- and "String"- Shortcuts
      *SingleChar will save a Keypress (ENTER or SPACE)

- Added an option wich controlls if a click on a button without an appropriate action opens the submenu or not (NOACTION>GOSUB ...


In the Attachment a prepared Example with the following setting:

Code: [Select]
( ;-------------------------------------------------
(MENU,SCALE 150)
(MENU,SCALE,INI 150)
(MENU,SCALE,INCREMENTER 9)
;-------------------------------------------------
(COLOR,MARKER,LEFT 1)
(COLOR,MARKER,RIGHT 3)

(COLOR,TEXT,SYM,GRAPHICMODE 9)
(COLOR,TEXT,SYM,TEXTMODE 2)

(COLOR,TEXT,TITLE 2)

(COLOR,TEXT,LASTCOMMAND 1)

(COLOR,BOUNDARY 8)
(COLOR,GUIDE 3)
;-------------------------------------------------
(MARKER,SHOW:HIDE T)
(GRAPHIC:TEXT T)
(NOACTION>GOSUB NIL)
(DISPLAYALL NIL)
(SNAPPY 'T)
(ONECHARSHORTCUT NIL)
;-------------------------------------------------
(KEY,OPENSUB 9) ;TAB
(KEY,TOGGLEMARKER 151);F11
(KEY,TOGGLEDISPLAYMODE 31) ;F12
(KEY,RESTORESCALE 35) ;#
(KEY,SCALEUP 43) ;+
(KEY,SCALEDOWN 45) ;-
(KEY,SNAPPY 6) ;F3
(KEY,SHOWALL 25) ;F4
)

The setting can also modified from outside... it is an assoc-list wich can be found at (cadr C:Draw-Modify)
**NOTE: take care by changing "COMMAND,LAST":
                  structure: ("title" (command "_close"))


To create a Menu at ur own, u need an other Script than that... Just write my a PM ;)


[EDIT: found a lil bug with the display of the last command: fixed and reattached]


Greets
reltro

Title: Re: Radial Menu
Post by: reltro on June 04, 2014, 05:54:14 PM
DCL is simple as pie.
Here's an example to show exactly how easy it is.
Code: [Select]
img : image_button
{
height = 5.5;
width = 18.00;
fixed_width = true;
fixed_height = true;
alignment = centered;
color = -2;
}
txt : text {fixed_width = true; alignment = centered; }
col : column {fixed_width = true; width = 28; }

  //---------------------------------------------------------------------------------------------------------


  controlvalves : dialog {
   label = "EPCO Control Valves"; spacer;
: row
{
   : col
   {
: img { key = "Slide1"; } : txt { label = "Hand Op. Butterfly Control Valve"; } spacer_1;
: img { key = "Slide2"; } : txt { label = "Hand Op. 3-Way Control Valve"; } spacer_1;
: img { key = "Slide3"; } : txt { label = "Diaph. Act. w Ind. Valve Action"; } spacer_1;
: img { key = "Slide4"; } : txt { label = "Butterfly CV (Shut-Down Valve)"; } spacer_1;
: img { key = "Slide5"; } : txt { label = "Globe Control Valve"; } spacer_1;
: img { key = "Slide6"; } : txt { label = "Ball Type Control Valve"; }
   }
   : col
   {
: img { key = "Slide7"; } : txt { label = "Control Valve w Hand Actuator"; } spacer_1;
: img { key = "Slide8"; } : txt { label = "Angle Control Valve"; } spacer_1;
: img { key = "Slide9"; } : txt { label = "Pilot Valve w Manual Reset"; } spacer_1;
: img { key = "Slide10"; } : txt { label = "Backpressure Reg.- Int. Sensing"; } spacer_1;   
: img { key = "Slide11"; } : txt { label = "Backpressure Reg.- Ext. Sensing"; } spacer_1;
: img { key = "Slide12"; } : txt { label = "Pres. Red. Reg.- Int. Sensing"; }
   }
}
spacer; cancel_button;     
}///manualvalves
obviously this DCL is meant to display image slides but it shows how simple it is to modify ,
you'd simply set your controls for what you are going to be using at the top of the routine,
and then "call" them throughout your dcl, using the
: col/ : row
commands in order to organize them where you'd like them to appear.
There are more commands and controls that could be defined, such as text PARAGRAPHS, which would allow for multiline text formatting a bit better than the text controls shown in this example.
Wish I could do it for you, don't have the time quite yet!


Thanks Bhull1985 for this

it is a nice example... It should'nt be so hard ;) wanna try it...
If u are faster it would be great ;)


Check out the new version an tell me what u think ;)

reltro
Title: Re: Radial Menu
Post by: andy_lee on June 04, 2014, 08:22:02 PM
Hey People...

There is a new Version of RadialMenu... :)

Version 2.1a

- Added a Keyword-Menu to modify look and behaviour, wich can be opened by pressing ? in the center or the free space below.
      * there the option-keyword ? gives a feedback and redirect u to this URL

- Added a Snappy-Mode so the Menu follows the cursor

- Added a option to show the whole Menu at the same time

- Added the possiblity to switch between "singleChar"- and "String"- Shortcuts
      *SingleChar will save a Keypress (ENTER or SPACE)

- Added an option wich controlls if a click on a button without an appropriate action opens the submenu or not (NOACTION>GOSUB ...


In the Attachment a prepared Example with the following setting:

Code: [Select]
( ;-------------------------------------------------
(MENU,SCALE 150)
(MENU,SCALE,INI 150)
(MENU,SCALE,INCREMENTER 9)
;-------------------------------------------------
(COLOR,MARKER,LEFT 1)
(COLOR,MARKER,RIGHT 3)

(COLOR,TEXT,SYM,GRAPHICMODE 9)
(COLOR,TEXT,SYM,TEXTMODE 2)

(COLOR,TEXT,TITLE 2)

(COLOR,TEXT,LASTCOMMAND 1)

(COLOR,BOUNDARY 8)
(COLOR,GUIDE 3)
;-------------------------------------------------
(MARKER,SHOW:HIDE T)
(GRAPHIC:TEXT T)
(NOACTION>GOSUB NIL)
(DISPLAYALL NIL)
(SNAPPY 'T)
(ONECHARSHORTCUT NIL)
;-------------------------------------------------
(KEY,OPENSUB 9) ;TAB
(KEY,TOGGLEMARKER 151);F11
(KEY,TOGGLEDISPLAYMODE 31) ;F12
(KEY,RESTORESCALE 35) ;#
(KEY,SCALEUP 43) ;+
(KEY,SCALEDOWN 45) ;-
(KEY,SNAPPY 6) ;F3
(KEY,SHOWALL 25) ;F4
)

The setting can also modified from outside... it is an assoc-list wich can be found at (cadr C:Draw-Modify)
**NOTE: take care by changing "COMMAND,LAST":
                  structure: ("title" (command "_close"))


To create a Menu at ur own, u need an other Script than that... Just write my a PM ;)


[EDIT: found a lil bug with the display of the last command: fixed and reattached]


Greets
reltro

Good job! reltro, Thanks for sharing.
Title: Re: Radial Menu
Post by: CAB on June 04, 2014, 11:58:28 PM
reltro,
Very creative programing.  :)
Title: Re: Radial Menu
Post by: ROBBO on June 05, 2014, 02:04:40 AM
reltro - it just gets better and better!
Title: Re: Radial Menu
Post by: WILL HATCH on June 05, 2014, 02:22:42 AM
You lispers amaze me. I get so lost in the extra syntax, but here you are creating these ridiculous routines.  I am so spoiled by the meaningful names of the functions I create and use, and the autocomplete in visual studios.
I dare you to come to the dark side  :-D we have cookies
Title: Re: Radial Menu
Post by: roy_043 on June 05, 2014, 03:20:03 AM
@ reltro:
Two DCL tutorials that may be of interest:
http://web2.airmail.net/terrycad/Tutorials/MyDialogs.htm
http://www.jefferypsanders.com/autolisp_DCL.html
Title: Re: Radial Menu
Post by: Bhull1985 on June 05, 2014, 07:54:47 AM
PM me the data you wish to display, if you want to keep it off the forum, or alternatively you can just post the info to be wrapped in a DCL here, and I'll do my best to help get it done. Just a matter of time, been really busy here.
Title: Re: Radial Menu
Post by: reltro on June 06, 2014, 08:20:33 AM
Hey People...

Thanks all for the nice words... pretty good to know it makes sense to so such a stuff...

VERSION 2.2a

@roy_043
Thanks for the links... will look at them closely, it seems to be a good start....

@Bhull1985
Thanks for ur offer, will write u soon...

@WILL HATCH
Enabled the Continous-Mode  :kewl:

BUT...
The command evaluated has to have an end...
The menu pops up again if (= (getvar 'cmdactive) 0)

In the attachment I rebuilt the Line-command to immitate the internal.
Code - Auto/Visual Lisp: [Select]
  1. (    (lambda (P #cmdecho / catch break PointList)
  2.         (setvar 'cmdecho 0)
  3.         (command "_.Line" P)
  4.         (setq PointList (cons P PointList))
  5.         (while
  6.             (not
  7.                 (or
  8.                     (vl-catch-all-error-p
  9.                         (setq catch
  10.                             (vl-catch-all-apply
  11.                                 '(lambda ( / c)
  12.                                     (if (> (length PointList) 2)
  13.                                         (progn
  14.                                             (initget "Undo Close")
  15.                                             (setq c (getpoint (car PointList) "\nSpecify next point or [Close/Undo]:"))
  16.                                         )
  17.                                         (progn
  18.                                             (initget "Undo")
  19.                                             (setq c (getpoint (car PointList) "\nSpecify next point or [Undo]:"))
  20.                                         )
  21.                                     )
  22.                                     (cond
  23.                                         ((= c "Undo")
  24.                                             (setq P (car PointList))
  25.                                             (setq PointList (cdr PointList))
  26.                                             (command "_Undo")
  27.                                         )
  28.                                         ((= c "Close")
  29.                                             (command "_Close")
  30.                                             (setq break 'T)
  31.                                         )
  32.                                         (c
  33.                                             (setq PointList (cons c PointList))
  34.                                             (command c)
  35.                                         )
  36.                                         ('default (setq break 'T))
  37.                                     )
  38.                                 )
  39.                             )
  40.                         )
  41.                     )
  42.                     break
  43.                 )
  44.             )
  45.         )
  46.         (while (= (getvar 'cmdactive) 1)
  47.             (command)
  48.         )
  49.         (if (vl-catch-all-error-p catch)
  50.             (    (lambda (a / )
  51.                     (if (not (wcmatch (strcase a) "*EXIT*,*BREAK*,*CANCEL*"))
  52.                         (*error* a)
  53.                     )
  54.                 )
  55.                 (vl-catch-all-error-message catch)
  56.             )
  57.         )
  58.         (setvar 'cmdecho #cmdecho)
  59.         (princ)
  60.     )
  61.     (getpoint "Specify first point: ")
  62.     (getvar 'cmdecho)
  63. )
  64.  

If someone wants to immitate the others I will insert them to have a continous Menu all over...


reltro
Title: Re: Radial Menu
Post by: WILL HATCH on June 08, 2014, 02:02:39 AM
Enabled the Continous-Mode  :kewl:
:kewl:

With the update to 2015 we can do synchronous commands in .net now.... wink wink
Title: Re: Radial Menu
Post by: reltro on June 09, 2014, 02:43:31 PM
Enabled the Continous-Mode  :kewl:
:kewl:

With the update to 2015 we can do synchronous commands in .net now.... wink wink

ähm ok, that sounds very strange, how does it work? I know just a lil C#.net... I have 2015 here... So if u have time would be nice to give an example how this works? ;)
Whats about (getvar 'cmdactive)? is it 0?



modified the Keyword-Menu by pressing ? on the center
found a bug and rewrote the whole menu...

fixed "Draw-Modify"-Menu attached....


@Bhull1985
In the attchment is also a lambda-expr wich IS the Keyword-Menu...
I would be thankful if u want to build the dcl  :-P
Title: Re: Radial Menu
Post by: kruuger on June 09, 2014, 03:26:11 PM
@Bhull1985
I would be thankful if u want to build the dcl  :P
just draw something in paint. for sure we can easily make something with dcl.
k.
Title: Re: Radial Menu
Post by: ROBBO on June 10, 2014, 04:53:20 AM
All,

Please find attached version of Radial Menu for Text and Dims.

Special thanks to reltro for all his hard work and permission allowing me to compile this.

Feedback welcome.

Kind regards, Robbo.

Modified: Updated to enable MLeader command to operate with mtext window
Title: Re: Radial Menu
Post by: reltro on June 10, 2014, 06:56:21 AM
All,

Please find attached version of Radial Menu for Text and Dims.

Special thanks to reltro for all his hard work and permission allowing me to compile this.

Feedback welcome.

Kind regards, Robbo.

Modified: Updated to enable MLeader command to operate with mtext window

Tanks ROBBO for ur nice work! ;)
[EDIT: as I have seen in the "raw"-Menu, u use different sub-routines as C:t0 (or similar)... would be nice to add them]


@all others...
every one is welcome to compile his own menu... Just write me a PM or an EMail... I will send u the "compiler"...

The only condition to get it, is that the finished Menu will be shared and posted here... ;)
It would be nice to get a lot of different RadialMenus to work with :)


@Bhull1985
I would be thankful if u want to build the dcl  :P
just draw something in paint. for sure we can easily make something with dcl.
k.
will draw some soon... :) thanks for ur nice offer...

It would be also very nice to have a DCL to create the RadialMenu... but this would be a next step...
the time is lil at the moment...

greets
reltro

Title: Re: Radial Menu
Post by: Bhull1985 on June 10, 2014, 07:43:58 AM
Yes, just tell me the information to display in a DCL
and I will make it for you :)
Title: Re: Radial Menu
Post by: ROBBO on June 10, 2014, 10:32:21 AM
All,

Please find attached version of Radial Menu for Text and Dims.

Special thanks to reltro for all his hard work and permission allowing me to compile this.

Feedback welcome.

Kind regards, Robbo.

Modified: Updated to enable MLeader command to operate with mtext window

Apologies to those who have downloaded the TEXT_DIMS.lsp. I didn't add the functions to file to allow dialog window for the Mtext and MLeader commands, therefore will not work.

Have added the following code to the file in the OP above:

Code - Auto/Visual Lisp: [Select]
  1. ;; mtext
  2. (defun c:MT ()
  3.         (initdia)
  4.         (command "_.mtext" pause pause)(command)(command)
  5.         (princ)
  6. )
  7. ;; mtext with 0 width
  8. (defun c:T0 (/ pt)
  9.         (initdia)
  10.         (command "_.mtext")
  11.         (if (setq pt (getpoint "\nSpecify insertion point <first corner>: "))
  12.                 (command "_non" pt "_W" 0.)
  13.         )
  14.         (princ)
  15. )
  16. ;; mleader
  17. (defun c:ML1 ()
  18.         (initcommandversion)
  19.         (command "_.mleader")
  20.         (while (> (getvar 'cmdactive) 0)
  21.                 (command pause)
  22.         )
  23.         (princ)
  24. )

Should work fine now. When I tested it, I obviously have the raw data loaded, therefore worked fine.

Kind regards, Robbo.
Title: Re: Radial Menu
Post by: WILL HATCH on June 10, 2014, 11:19:42 PM
ähm ok, that sounds very strange, how does it work? I know just a lil C#.net... I have 2015 here... So if u have time would be nice to give an example how this works? ;)
Whats about (getvar 'cmdactive)? is it 0?

check out http://through-the-interface.typepad.com/through_the_interface/2014/03/autocad-2015-calling-commands.html (http://through-the-interface.typepad.com/through_the_interface/2014/03/autocad-2015-calling-commands.html) where they show us how to do it.  Very easy!

Code - C#: [Select]
  1. using Autodesk.AutoCAD.ApplicationServices;
  2. using Autodesk.AutoCAD.EditorInput;
  3. using Autodesk.AutoCAD.Runtime;
  4.  
  5. namespace CommandCalling
  6. {
  7.   public class Commands
  8.   {
  9.     [CommandMethod("IBS")]
  10.     public void InsertBlockSync()
  11.     {
  12.       var doc =
  13.         Application.DocumentManager.MdiActiveDocument;
  14.       var ed = doc.Editor;
  15.  
  16.       // Our insertion point is hardcoded at 10,10
  17.  
  18.       ed.Command("_.INSERT", "TEST", "10,10", 1, 1, 0);
  19.  
  20.       ed.WriteMessage("\nWe have inserted our block.");
  21.     }
  22.  
  23.     [CommandMethod("IBA")]
  24.     async public void InsertBlockAsync()
  25.     {
  26.       var doc =
  27.         Application.DocumentManager.MdiActiveDocument;
  28.       var ed = doc.Editor;
  29.  
  30.       // Let's ask the user to select the insertion point
  31.  
  32.       await ed.CommandAsync(
  33.         "_.INSERT", "TEST", Editor.PauseToken, 1, 1, 0
  34.       );
  35.  
  36.       ed.WriteMessage("\nWe have inserted our block.");
  37.     }
  38.   }
  39. }
Title: Re: Radial Menu
Post by: reltro on June 12, 2014, 03:56:00 AM
Thanks WILL HATCH...
Will have a look at it... At the moment I don't really get the point, but I'm going to check it out...

SRY people, but at the moment I don't have any time to think about this. Will be back in about 2 weeks, hope its not too late to build the DCL stuff then... Just a LITTLE busy at the moment...

Thanks in advance

reltro...
Title: Re: Radial Menu
Post by: ROBBO on June 13, 2014, 08:43:18 AM
Text enhancements made.
Title: Re: Radial Menu
Post by: ROBBO on June 17, 2014, 02:38:53 AM
Dimension enhancements made.
Title: Re: Radial Menu
Post by: liuhaixin88 on June 17, 2014, 03:09:01 AM
Dimension enhancements made.

Thanks ROBBO, Great routine !

You and Reltro are the same person ?
Title: Re: Radial Menu
Post by: reltro on June 17, 2014, 03:26:32 AM
Dimension enhancements made.

Thanks ROBBO, Great routine !

You and Reltro are the same person ?

:D not at all... I sent him, Robbo, the "compiler"... He asked for it ;)


Thanks Robbo... nice stuff...
The file is now pretty big, hm... U draw a lot of lines in the graphics... they look nice...
nice-looking stuff hasto be big I think :P


greets
Title: Re: Radial Menu
Post by: ROBBO on June 17, 2014, 03:50:51 AM
liuhaixin88,

All the credit goes to reltro and his hard work and generosity.

I just compiled the text-dims routine from reltro's program and raw data, and made it look pretty.

Thanks Robbo... nice stuff...
The file is now pretty big, hm... U draw a lot of lines in the graphics... they look nice...
nice-looking stuff hasto be big I think :P

Reltro,

I noticed that, although once loaded, I haven't experienced any performance issues. Use it all the time.

Extremely useful  :kewl:

Kindest regards, Robbo.
Title: Re: Radial Menu
Post by: reltro on June 23, 2014, 04:06:12 AM
new version - RADIAL MENU 2.4

Now with a DCL-control to change look and behaviour...
Its me first DCL, so tell me what u think! ;)
Its really easy :)

:-D
Big thanks to ROBBO to build up such a nice draw-modifiy-menu!!!

CHANGES:
- the routine now does not exit with an *error* by pressing ESC, so it can be used as a subroutine
- added a key for the "noAction>goSub"option (forgot about it)
- added an Overview for the current Menu and his actions/shortcuts
- changed the "writeToFile"
        * in the previous Version changes were not written to file until an recall of the routine
        * last used command is skipped


EDIT: Writing the Menu to File would be overwrite the inserted Subroutines... fixed and reattached... They are now readed first and rewritten to the new file

So far so good...
enjoy...
Hope its useful to someone... :)


reltro
Title: Re: Radial Menu
Post by: andy_lee on June 23, 2014, 06:30:32 AM
new version - RADIAL MENU 2.4

Now with a DCL-control to change look and behaviour...
Its me first DCL, so tell me what u think! ;)
Its really easy :)

:-D
Big thanks to ROBBO to build up such a nice draw-modifiy-menu!!!

CHANGES:
- the routine now does not exit with an *error* by pressing ESC, so it can be used as a subroutine
- added a key for the "noAction>goSub"option (forgot about it)
- added an Overview for the current Menu and his actions/shortcuts
- changed the "writeToFile"
        * in the previous Version changes were not written to file until an recall of the routine
        * last used command is skipped


EDIT: Writing the Menu to File would be overwrite the inserted Subroutines... fixed and reattached... They are now readed first and rewritten to the new file

So far so good...
enjoy...
Hope its useful to someone... :)


reltro

Cool, Big thanks reltro.
Title: Re: Radial Menu
Post by: ROBBO on June 23, 2014, 11:53:14 AM
TEXT-DIMS menu updated for version 2.4.

Again thanks to reltro for his hard work and update.

Kind regards, Robbo.
Title: Re: Radial Menu
Post by: reltro on June 24, 2014, 06:31:10 AM
 :ugly: 400 downloads? thats a lot... but just one feedback... :|
nevermind....


I found a bug wich I "solved" long time ago, but not in the right manner... The above Version does not work properly within all UCS; Work only if the CoordinateSystem is aligned to the display. I don't know why I did not find this bug earlier...

I allready solved that issue for all planar UCS (planar to the Display), but I can't figure out how to do it for a 3DView, like isometric.

:?
I have two Coordinates returned for (grread) and have to calculate the distance between them, and the angle measured from the XAxis (polarCoordinates); but not in the CoordinateSystem of the Drawing. They have to be in the CoordinateSystem of the Display.... I get the right angle, but the distance is to "short" "long"....

Anyone can help? so I can post the fixed version...


greets reltro
Title: Re: Radial Menu
Post by: ROBBO on June 24, 2014, 06:46:08 AM
A slight bug in the rectangle commands to return to menu after command.

Commands to be amended to:

Code - Auto/Visual Lisp: [Select]
  1. (command "_.Rectang" pause "_r" "0" (while (/= (getvar 'cmdactive) 0) (command pause)))

Code - Auto/Visual Lisp: [Select]
  1. (command "_.rectang" P1 "_rotation" (getpoint P1) (while (/= (getvar 'cmdactive) 0) (command pause)))

respectively to return to menu after placement.

Cheers, Robbo.

p.s. to reiterate reltro's comment:

:ugly: 400 downloads? thats a lot... but just one feedback... :|
nevermind....

Feedback negative or positive is most welcome.
Title: Re: Radial Menu
Post by: reltro on June 24, 2014, 07:58:30 AM

p.s. to reiterate reltro's comment:

:ugly: 400 downloads? thats a lot... but just one feedback... :|
nevermind....

Feedback negative or positive is most welcome.

Thanks Robbo,
postive or negative! just constructiv ;)

As I see that every action in the Menu ends with the same while loop
Code: [Select]
(command ... (while (= (getvar 'cmdactive) 1) (command pause))) I added this piece of code in the routine it self. So its not necassary to add it all the time.
Now we can write simply the command itself...
Sent u the (your) modified Raw-File...

greets reltro
Title: Re: Radial Menu
Post by: andy_lee on June 24, 2014, 08:34:56 AM
A slight bug in the rectangle commands to return to menu after command.

Commands to be amended to:

Code - Auto/Visual Lisp: [Select]
  1. (command "_.Rectang" pause "_r" "0" (while (/= (getvar 'cmdactive) 0) (command pause)))

Code - Auto/Visual Lisp: [Select]
  1. (command "_.rectang" P1 "_rotation" (getpoint P1) (while (/= (getvar 'cmdactive) 0) (command pause)))

respectively to return to menu after placement.

Cheers, Robbo.

p.s. to reiterate reltro's comment:

:ugly: 400 downloads? thats a lot... but just one feedback... :|
nevermind....

Feedback negative or positive is most welcome.


Thanks reltro & robbo
A little advice, I think can increase a little more color for the graphical interface.
Title: Re: Radial Menu
Post by: reltro on June 24, 2014, 08:44:21 AM
Thanks reltro & robbo
A little advice, I think can increase a little more color for the graphical interface.

What do u mean?
U allready tried pressing ? on the center? A DCL pops up... There u can adjust the Colors and KeyPresses... Just have a look...

greets
reltro
Title: Re: Radial Menu
Post by: ribarm on June 24, 2014, 09:52:24 AM
I allready solved that issue for all planar UCS (planar to the Display), but I can't figure out how to do it for a 3DView, like isometric.

Lee Mac solved this question in his star.lsp... I don't know if it's going to be helpful, but compare these two codes... First one is with snaps and work only in top of WCS in WCS :
http://www.theswamp.org/index.php?topic=12813.msg521921#msg521921

And this second one works with snaps and in all UCS/Views :
http://www.theswamp.org/index.php?topic=12813.msg522024#msg522024

Regards, M.R.
Title: Re: Radial Menu
Post by: ROBBO on June 24, 2014, 10:13:25 AM
Thanks reltro & robbo
A little advice, I think can increase a little more color for the graphical interface.

What do u mean?
U allready tried pressing ? on the center? A DCL pops up... There u can adjust the Colors and KeyPresses... Just have a look...

greets
reltro
Title: Re: Radial Menu
Post by: TimSpangler on June 24, 2014, 12:38:06 PM
The concept is great.  I am in the process of trying to incorporate it into my daily routine.  I curently use command to temporarily change out the right click menu to do something similar, but this is more heads up (I think)

Great work!
Title: Re: Radial Menu
Post by: trogg on June 24, 2014, 06:40:27 PM
I really like this menu. Thank you for putting it together. It reminds me of the marking menu they were trying to roll out a few years ago. I think that ACAD electrical uses it...
But this is definitely a great way to bring focus to the screen.

I have been trying to understand how to customize this if needed, but the file size is just too big for the VLIDE to handle and when i try to understand what is going on in note pad, it is just too jumbled.

The way that I would like to try to utilize this is to have a text-dims version that could deliver some standards that people tend to not even acknowledge that they exist at work, they tend to override text styles and make look like they adhere to standards. This is really getting annoying to many people and a menu like this might actually make using the "standards" fun.

Usually there are a couple of different text styles, with the default text height set to 0 (zero) and we have a tool that when someone clicks it, the tool will set the height for the various types of text  like (Title, Sub Title, General)...

If the radial menu could be easier for me to understand and easier to customize, I think that this could replace some of the tools that people tend to ignore.

Thanks again to Reltro & Robbo for doing this.
~Greg
Title: Re: Radial Menu
Post by: Lee Mac on June 24, 2014, 06:51:02 PM
Incredible work reltro, I'm impressed  8-)
Title: Re: Radial Menu
Post by: reltro on June 24, 2014, 06:53:47 PM
I really like this menu. Thank you for putting it together. It reminds me of the marking menu they were trying to roll out a few years ago. I think that ACAD electrical uses it...
But this is definitely a great way to bring focus to the screen.

I have been trying to understand how to customize this if needed, but the file size is just too big for the VLIDE to handle and when i try to understand what is going on in note pad, it is just too jumbled.

The way that I would like to try to utilize this is to have a text-dims version that could deliver some standards that people tend to not even acknowledge that they exist at work, they tend to override text styles and make look like they adhere to standards. This is really getting annoying to many people and a menu like this might actually make using the "standards" fun.

Usually there are a couple of different text styles, with the default text height set to 0 (zero) and we have a tool that when someone clicks it, the tool will set the height for the various types of text  like (Title, Sub Title, General)...

If the radial menu could be easier for me to understand and easier to customize, I think that this could replace some of the tools that people tend to ignore.

Thanks again to Reltro & Robbo for doing this.
~Greg

Hey trogg...
:) I can't even read the code inside the menu's posted here...
They are compiled with an other routine, also written in lisp... The input is very simple...

I can send u the compiler, and a Raw-file; short, all needed...
So u can put it togheter...

I have just a single wish: If u build up some RadialMenu, share it! Allright? So, send me ur E-mail, and I will send u the compiler... ;)


Incredible work reltro, I'm impressed  8-)

 :mrgreen: thanks a lot Lee...

greets reltro
Title: Re: Radial Menu
Post by: trogg on June 24, 2014, 07:07:35 PM


I will be happy to share whatever I'm able to piece together

Thanks
Title: Re: Radial Menu
Post by: ROBBO on June 25, 2014, 02:18:00 AM
Any improvements  and suggestions are most welcome. Adapting the text-dims menu to suit your CAD standards is a great idea and something I am considering too!

I have a standard template with all text styles etc. Perhaps with the help of Lee Mac's Steal program will help simplify this.

Look forward to seeing other menus and results.

Kindest regards, Robbo.

Title: Re: Radial Menu
Post by: Hugo on June 25, 2014, 02:56:42 AM
@ Robbo

super thank you

Since Autodesk can take an example  :-) :-)

super Danke

Da kann sich Autodesk ein Beispiel nehmen.

Title: Re: Radial Menu
Post by: reltro on June 25, 2014, 03:25:02 AM
new Version - Radial Menu 2.5

added:
  - The "buttons" can be modified in size

known bugs:
  - does not work properly in non-planar views, like isometric


draw-modify:
added a functionality wich I call "VisibilitySpace". check it Out...


[EDIT: Updated the attachment to solve an issue reported by WillHatch, thanks a lot!]

Any feedback is welcome...

greets reltro
Title: Re: Radial Menu
Post by: reltro on June 25, 2014, 04:01:00 AM
To modify the Colors from Outside, for Example as an action of an reactor (layoutswitched come in mind.)

Code - Auto/Visual Lisp: [Select]
  1. (defun RadialMenu:changeColor   (   name
  2.                                     COLOR,BOUNDARY
  3.                                     COLOR,GUIDE
  4.                                     COLOR,MARKER,LEFT
  5.                                     COLOR,MARKER,RIGHT
  6.                                     COLOR,TEXT,SYM,GRAPHICMODE
  7.                                     COLOR,TEXT,SYM,TEXTMODE
  8.                                     COLOR,TEXT,TITLE
  9.                                     COLOR,TEXT,LASTCOMMAND
  10.                                     /
  11.                                     V
  12.                                     S
  13.                                     lastColors
  14.                                 )
  15.  
  16.     (setq V     '(
  17.                     COLOR,BOUNDARY
  18.                     COLOR,GUIDE
  19.                     COLOR,MARKER,LEFT
  20.                     COLOR,MARKER,RIGHT
  21.                     COLOR,TEXT,SYM,GRAPHICMODE
  22.                     COLOR,TEXT,SYM,TEXTMODE
  23.                     COLOR,TEXT,TITLE
  24.                     COLOR,TEXT,LASTCOMMAND
  25.                 )
  26.           S     (eval (nth 1 (eval name)))
  27.     )
  28.    
  29.     (setq lastColors
  30.         (mapcar
  31.             '(lambda (a / )
  32.                 (cadr (assoc a S))
  33.             )
  34.             V
  35.         )
  36.     )
  37.    
  38.     (eval
  39.         (vl-list* 'defun-q name '(/)
  40.             (list 'quote
  41.                 (mapcar
  42.                     '(lambda (a / b)
  43.                         (if (member (car a) V)
  44.                             (if (and
  45.                                     (numberp (setq b (eval (car a))))
  46.                                     (< (setq b (abs (fix b))) 256)
  47.                                 )
  48.                                 (list (car a) b)
  49.                                 a
  50.                             )
  51.                             a
  52.                         )
  53.                     )
  54.                     S
  55.                 )
  56.             )
  57.             (cddr (eval name))
  58.         )
  59.     )
  60.     lastColors
  61. )
  62.  

Example:
(all red)
Code: [Select]
(RadialMenu:changeColor 'C:draw-modify 1 1 1 1 1 1 1 1)

*** Returns previous Color-settings

greets reltro
Title: Re: Radial Menu
Post by: reltro on June 25, 2014, 04:33:05 AM
@ Robbo

super thank you

Since Autodesk can take an example  :-) :-)

super Danke

Da kann sich Autodesk ein Beispiel nehmen.

:mrgreen:
Thanks hugo for ur feedback, nice to hear

Dank dir Hugo, tut gut zu hören dass es dir gefällt... =)

greets reltro
Title: Re: Radial Menu
Post by: Hugo on June 25, 2014, 05:42:03 AM
SORRY Wrong name

Yes super Lisp reltro  :-D :-D :-D


SORRY  Falsche Namen

Ja super  Lisp reltro
Title: Re: Radial Menu
Post by: TimSpangler on June 26, 2014, 01:03:08 PM

added a functionality wich I call "VisibilitySpace". check it Out...

Any feedback is welcome...

greets reltro

I use visibility all the time, so having it in the menu is great.  the only feedback I would give is:  When you switch the visibility to "invisible" the "Hide" button should really say "UnHide".

Otherwise, great addition!
Title: Re: Radial Menu
Post by: reltro on June 26, 2014, 01:44:29 PM

added a functionality wich I call "VisibilitySpace". check it Out...

Any feedback is welcome...

greets reltro

I use visibility all the time, so having it in the menu is great.  the only feedback I would give is:  When you switch the visibility to "invisible" the "Hide" button should really say "UnHide".

Otherwise, great addition!

Hey Tim,
First, thanks for the great feedback.
My thinking was: "hide" an object from current Visibilty-Space ;)
> hide from invisible-Space makes it visible
> other way around, u know ;)

But, u gave me a great hint.
At the moment the displayed  vectors are pre-calculated (except for the last command) and "hard-coded" (the compiler did this ;) ) in the menu.
It may should be possible to make the displayed  text, and graphic sensitive to the current conditions.........

In the case of the Title-Text (the vectors shown in green, below) it wouldn't be so hard (the function is allready part of the complied Menu), but it would be also neceassary to give a possibility to control wich one is displayed on wich condition.
hmmmm.... I have to think about it, but it would be nice I guess.

At the moment I'm trying to reduce the File-size of the compiled RadialMenu. Draw-Modify was about 3MB, now it has allready 2,5MB :)
This addition would increase the file-size again.
I want to keep the file-size small, at the other hand, I think that the most of the vectors should be precalculated, so the Menu can run smoothly, without multiple calculations of the same.


If u have a suggestion what this condition-senstive-display should deliver and how it can be implemented in the most generic way, any ideas are very welcome =)
My first idea is to add a new "tag" in the raw-file, a lambda-expr wtithout any input, wich returns an Integer, wich is interpreted like (nth [returned integer] [combination of graphic and title-text])...

greets retlro
Title: Re: Radial Menu
Post by: WILL HATCH on June 27, 2014, 01:11:51 PM
Damn... this got complicated fast.  Very nice gents!

When the settings page is opened, the window's close button does not work, the only way to close is the 'OK' button

I like how you've added the hide mechanism.  I'm curious if it would be difficult to allow you to have a button (or when hovering over the show all button) which temporarily unhides the hidden items

Also seeing that when we are in a command which requires a selection (move for example) we aren't allowed to do windows (acad 2013 vanilla, win 7 x64)
Title: Re: Radial Menu
Post by: hanhphuc on June 28, 2014, 03:15:51 AM
new Version - Radial Menu 2.5
Any feedback is welcome...

Wow very creative work it must be nice for Win8 touch-screen ACAD user! (In future maybe stylus to replace mouse?) Does it work auto-rotate screen?

anyway, i must say Excellent job!
Thank you :)
Title: Re: Radial Menu
Post by: reltro on June 28, 2014, 06:06:05 AM
Damn... this got complicated fast.  Very nice gents!
Jup ;)

When the settings page is opened, the window's close button does not work, the only way to close is the 'OK' button
I knew this, but I don'tbuilt this up... its my first DCL, so there may be lotof issues... Anyway, I didn't investigate this because the changes are done immidiatly, so a 'close'-Button would be the same as the 'OK'-button...

I like how you've added the hide mechanism.  I'm curious if it would be difficult to allow you to have a button (or when hovering over the show all button) which temporarily unhides the hidden items
It wouldn't be so hard to implemnt this, but, in general im working on the compiler wich "calculates" the Menu, and the problem about it is that such a function and his namespace would collide with the namespace of the Menu itself. So it may not be the best Idea to implement this in this routine. But at the moment I'm working on some similar addition for what its necessary to rethink the whole routine. Im allready on a good point and willing to think about this too... This would become v3.0 ;)
At the moment I have some issues with the namespaces, but I going to solve them :P

Also seeing that when we are in a command which requires a selection (move for example) we aren't allowed to do windows (acad 2013 vanilla, win 7 x64)
Fixed and reattached it above.
http://www.theswamp.org/index.php?topic=47177.msg523430#msg523430


It was not an issue f the compiler, it was just a mistake in defining the actions.
In the background there was running:
Code: [Select]
(Command "_.move" (while (= (getvar 'cmdactive) 1) (command pause)))Now its:
Code: [Select]
(Command "_.move" (ssget) "" (while (= (getvar 'cmdactive) 1) (command pause)))Beside, thanks for the report! :)

-----------------------------------------------------------------

new Version - Radial Menu 2.5
Any feedback is welcome...

Wow very creative work it must be nice for Win8 touch-screen ACAD user! (In future maybe stylus to replace mouse?) Does it work auto-rotate screen?

anyway, i must say Excellent job!
Thank you :)
First, Thanks for the ncice words :)
It would be nice to try it on Win8-touch...
I allready tried it with a Pen on big fat tablet... Its nice :)

Im not sure what u mean with 'auto-rotate scree'.
The RadialMenu, in generally knows every action/command acad knows ;) Its just an overhead...
but, it has to be hidden, wich is a reaction of a click...

greets reltro
Title: Re: Radial Menu
Post by: Lee Mac on June 29, 2014, 03:05:55 PM
When the settings page is opened, the window's close button does not work, the only way to close is the 'OK' button
I knew this, but I don'tbuilt this up... its my first DCL, so there may be lotof issues... Anyway, I didn't investigate this because the changes are done immidiatly, so a 'close'-Button would be the same as the 'OK'-button...

To fix this, simply add:
Code: [Select]
is_cancel = true;
to the attributes of the OK button.
Title: Re: Radial Menu
Post by: reltro on July 01, 2014, 06:41:44 AM
First, Thanks LEE MAC for this information... fixed it (attached here)

A new version is in work... Im coding a lot, but it isn't finished now, but I want to upload a Preview of v3.0....
Its just a preview, so there isn't all the comfort of v.2.5.1, but I'm doing some improvments and had to rewrite the whole routine...

 :kewl:
- Enabled a rollover-action for any button (in this preview of draw-modify the only one is at "showAll" - it temporarly shows the hidden entities...)
   * so, to check out this new feature, hide an object, and rollover the "showAll"-Button...
   * and the best is, without any Namespace-collision :)

- overworked the SubMenus... so if TAB is pressed while pointing on an button, the "sub-button" will shown at his own.
   * this was allready there in v2.5.1 but now, if a button is clicked and the action finished, the Menu pops up in the same submenu...

Im now going to make some holidays and will be back in a few days. Then a want to codeUp the preview to a fullVersion...
Since then, enjoy and tell me what u think...

greets reltro
Title: Re: Radial Menu
Post by: ROBBO on July 01, 2014, 06:57:15 AM
Yet again - good work reltro!

A great addition and update to v3.0.  :kewl:

All the best Robbo.
Title: Re: Radial Menu
Post by: MeasureUp on July 03, 2014, 03:28:52 AM
Can't just "read and run".
Thanks for sharing this nice routine.
Amazing!
Title: Re: Radial Menu
Post by: ROBBO on August 05, 2014, 02:39:44 AM
I have compiled a menu with some useful dimension lisp routines I commonly use - many familiar to some. Menu can also be activated with a right-click on 'dims' from the slightly tweaked text-dims menu.

Feedback welcome.

Version 2.5.

Best regards, Robbo
Title: Re: Radial Menu
Post by: andy_lee on August 05, 2014, 11:07:08 AM
I have compiled a menu with some useful dimension lisp routines I commonly use - many familiar to some. Menu can also be activated with a right-click on 'dims' from the slightly tweaked text-dims menu.

Feedback welcome.

Version 2.5.

Best regards, Robbo

ROBBO,Thanks for your hard work.
Title: Re: Radial Menu
Post by: reltro on August 05, 2014, 01:01:29 PM
@ROBBO
Thank u!
Nice stuff! ;)


Hey people...

Long time no see ;)
I am a lil busy since I'm doing a 40hour work. :|
At the beginning of the month I started with the Version 3.0 and have done a lot of coding, but its not finished yet.
I have some troubles with Wipeouts wich are drawn as a background for the Menu...

Attached is a Beta wich works great, but the Wipeouts are on the right place only if the Screen is plan to the WCS...
Maybe some of u has some experiences with Wipeouts and can help me or give me a tip? would be nice....
At the Moment I draw the Wipeouts using entmake on the origin of the WCS and then I transform them to the Menu's place...

I haven't done the DCL-stuff yet... Going to do it after the issue with the Wipeouts is solved....

Hope someone can help
greets reltro

[Edit: Reattached .lsp]
Title: Re: Radial Menu
Post by: Lee Mac on August 05, 2014, 01:11:50 PM
...the Wipeouts are on the right place only if the Screen is plan to the WCS... Maybe some of u has some experiences with Wipeouts and can help me or give me a tip? would be nice....

Maybe this (http://bit.ly/18MZEnB) can help?
Title: Re: Radial Menu
Post by: Hugo on August 05, 2014, 01:27:35 PM
Hello reltro

Get an error message   :-o

Title: Re: Radial Menu
Post by: reltro on August 05, 2014, 02:11:26 PM
Hello reltro

Get an error message   :-o

Hmmm... I don't know why this error happen... Its the same here...
Found the source... But its very strange... entmakex was returning nil... replaced it with entmake and entlast... all Good...
please, can u test it too?

Reattached corrected Code above (http://www.theswamp.org/index.php?topic=47177.msg525681#msg525681 (http://www.theswamp.org/index.php?topic=47177.msg525681#msg525681))

...the Wipeouts are on the right place only if the Screen is plan to the WCS... Maybe some of u has some experiences with Wipeouts and can help me or give me a tip? would be nice....

Maybe this (http://bit.ly/18MZEnB) can help?
Thanks Lee for the link...
This may help... Have to check it out...
I will post results soon, I hope... :)

greets reltro
Title: Re: Radial Menu
Post by: Hugo on August 06, 2014, 01:46:25 AM
Thank you works  :-)

Danke funktioniert
Title: Re: Radial Menu
Post by: reltro on August 30, 2014, 02:20:54 AM
...the Wipeouts are on the right place only if the Screen is plan to the WCS... Maybe some of u has some experiences with Wipeouts and can help me or give me a tip? would be nice....

Maybe this (http://bit.ly/18MZEnB) can help?

Hey People,
and thanks for LeeMac for the Link, it helped me a lot...=)

So, there is a corrected version of RadialMenu3 to improve the background of the RadialMenu -  Wipeouts are drawn, in various transparency, to fade out the drawn elements. See at ur own.
Since now I did not have time to implement the dcl-stuff to control the color- and key-settings like in the previous version, but I'm going to do this soon.

Here a compiled RadialMenu3 "C:draw-modify...

The settings to change behavour can be found on the "F"-Keys, from F3 to F9 and F11, F12... Just press some and u will see.
+ and - scale the menu, # rescale it to an initial value.

Enjoy
Greets reltro

Reattached draw-modify.lsp after an error reported by emk2012 (2nd time)
Title: Re: Radial Menu
Post by: andy_lee on August 30, 2014, 03:01:06 AM
Code: [Select]
(progn
(progn
;Visibility-Space
;
;Author  : reltro
;Version : 1.0
;
;==================================================================
(vl-load-com)

Version 1.0 ??  why not V3.0

error:
Code: [Select]
Command:  DRAW-MODIFY
>>> type shortcut [?]: Grread-loop: bad argument type: lentityp nil; error: bad
argument type: lentityp nil
Title: Re: Radial Menu
Post by: reltro on August 30, 2014, 03:06:15 AM
Hey emk2012...

Code: [Select]
(progn
(progn
;Visibility-Space
;
;Author  : reltro
;Version : 1.0
;
;==================================================================
(vl-load-com)

Version 1.0 ??  why not V3.0

Visibilty-Space is an other collection of functions.
Its not the engine wich works behind the RadialMenu, so it his has his own versioning. ;)

Quote
error:
Code: [Select]
Command:  DRAW-MODIFY
>>> type shortcut [?]: Grread-loop: bad argument type: lentityp nil; error: bad
argument type: lentityp nil

Hmmmmm... tought I tested it well...
When this error is raised?
right after the start?

greets reltro
Title: Re: Radial Menu
Post by: andy_lee on August 30, 2014, 03:21:32 AM
No start.

Code: [Select]
Command: DRAW-MODIFY
>>> type shortcut [?] OR <Line>: Grread-loop: bad argument type: lentityp nil;
error: An error has occurred inside the *error* functionAutoCAD variable
setting rejected: "CMDECHO" nil
Command:

I test in 2010.
BTW. What is the difference between  DRAW-MODIFY 3.0b.
Title: Re: Radial Menu
Post by: reltro on August 30, 2014, 03:36:02 AM
No start.

Code: [Select]
Command: DRAW-MODIFY
>>> type shortcut [?] OR <Line>: Grread-loop: bad argument type: lentityp nil;
error: An error has occurred inside the *error* functionAutoCAD variable
setting rejected: "CMDECHO" nil
Command:

I test in 2010.
BTW. What is the difference between  DRAW-MODIFY 3.0b.

Hm, ok... I have to investigate this... =( will be back soon...
The difference to 3.0b is that the wipeouts in this version are drawn in the right place in all UCS and Views, except 3D-Views...

greets reltro
Title: Re: Radial Menu
Post by: reltro on August 30, 2014, 03:50:41 AM
@emk2012

I reattached the file above. It may be the same error with entmakex like in the previous version of V3...
Can u test it please?

greets reltro
Title: Re: Radial Menu
Post by: andy_lee on August 30, 2014, 04:02:54 AM
@emk2012

I reattached the file above. It may be the same error with entmakex like in the previous version of V3...
Can u test it please?

greets reltro


Command: draw-modify
>>> type shortcut [?]: Grread-loop: no function definition:
VLA-PUT-ENTITYTRANSPARENCY
Command:
Command: draw-modify
>>> type shortcut [?]: Grread-loop: no function definition:
VLA-PUT-ENTITYTRANSPARENCY
Title: Re: Radial Menu
Post by: reltro on August 30, 2014, 04:11:37 AM
Command: draw-modify
>>> type shortcut [?]: Grread-loop: no function definition:
VLA-PUT-ENTITYTRANSPARENCY
Command:
Command: draw-modify
>>> type shortcut [?]: Grread-loop: no function definition:
VLA-PUT-ENTITYTRANSPARENCY

All right... so in ACAD2010 is no transparency? did know this...

Reattached it above...

greets reltro

BTW: thanks for ur tests :)
Title: Re: Radial Menu
Post by: andy_lee on August 30, 2014, 04:44:16 AM

All right... so in ACAD2010 is no transparency? did know this...
Reattached it above...
greets reltro
BTW: thanks for ur tests :)

Great Job! thanks for sharing.
Now ,is OK ,  Can see Interface, can operate.
But , When the operation is complete .
A message appears
Command: ; error: bad argument type: lentityp nil

Code: [Select]
Command:  DRAW-MODIFY
>>> type shortcut [?] OR <Circle>: _.circle Specify center point for circle or
[3P/2P/Ttr (tan tan radius)]:
Specify radius of circle or [Diameter] <310.1726>: 10
Command: ; error: bad argument type: lentityp nil

eg. draw a cicle .pickup center point,  Specify radius of circle,  circle is draw complete.
but Still tip: Command: ; error: bad argument type: lentityp nil
Title: Re: Radial Menu
Post by: reltro on August 30, 2014, 04:57:35 AM
Hm ok...
This is strange... I can not reproduce the error. Would be nice if u can help me to find the error.

Can u run some test?
01:  run the Menu, then press F9 (toggles Off the wipeouts) and then draw a circle?
02: Same above just with F7 (toggles Off the Title-Override)
03: Same above just with F8 (toggles Off the mouseover-action)

greets reltro
Title: Re: Radial Menu
Post by: andy_lee on August 30, 2014, 05:06:13 AM
Hm ok...
This is strange... I can not reproduce the error. Would be nice if u can help me to find the error.

Can u run some test?
01:  run the Menu, then press F9 (toggles Off the wipeouts) and then draw a circle?
02: Same above just with F7 (toggles Off the Title-Override)
03: Same above just with F8 (toggles Off the mouseover-action)

greets reltro


I test with lisp editor. but code is too big.  Now , Stops responding. :cry:
Title: Re: Radial Menu
Post by: andy_lee on August 30, 2014, 05:11:27 AM
toggles Off the wipeouts  , test .is the same.
toggles Off the Title-Override , test . is the same.
toggles Off the mouseover-action ,test .is the same.

Is the same.
Command: ; error: bad argument type: lentityp nil
Title: Re: Radial Menu
Post by: andy_lee on August 30, 2014, 06:33:17 AM
@ reltro
I test in AutoCAD Mechanical 2013,  is same too. (another comptuer, intel xeon E31235 , 16G RAM) ,

Code: [Select]
Command: ; error: bad argument type: lentityp nil
Title: Re: Radial Menu
Post by: reltro on August 30, 2014, 06:38:37 AM
Hey emk2012...

Thanks for ur tests... I'm not sure were this error happens, so its dig-into-time.
As u said the vlide can not handle, its going to be hard to find... have to install an other acad... now running 2014, and all works good...
Im not sure why the vlide can't handle it. Maybe its a problem that most of the code is written during the runtime... Could it be?

Will be back soon, I hope... :|

greets reltro